﻿# ##########################################################################
# Programme Python permettant de déterminer l'état final d'un système chimique
# pour une réaction du type Réactif1 + Réactif2 -> Produit1 + Produit2
# avec coefficients stoechiométriques pouvant être différents.

# Code à destination des élèves qui peuvent modifier le code sous les parties roses (ou à triples guillemets)

# Code volontairement peu optimisé (pas d'utilisation de listes) afin d'avoir
# une approche très simple pour les élèves non familiers avec le codage
# ##########################################################################
# O. CHAUMETTE - Lycée JP SARTRE - 69500 BRON - olivier.chaumette@ac-lyon.fr
# ##########################################################################
# version 1.1. du code - février 2019


# ##########################
# Quantités de matière initiales
""" Entrer ci-dessous les quantités de matières initiales en moles"""
# n1_ini  n2_ini pour les réactifs, n3_ini et n4_ini pour les produits. Variables de type "float" (réelles)
# réactifs:
n1_ini =2e-2
n2_ini =4e-2
# produits
n3_ini =0
n4_ini =0

# ###########################
# Nombres stoechiométriques
""" Entrer ci-dessous les nombres stoechiometriques"""
# stoechio: variables de type "nombre entier" contenant les coef stoechiométriques
# réactifs:
stoechio1=2
stoechio2=3
# produits
stoechio3=2
stoechio4=3

# ##########################
# Formules des réactifs et produits
""" Entrer ci-dessous les formules des espèces chimiques"""
# Variables de type "texte" contenant les formules, non mises en formes, des espèces.
# réactifs:
r1="Al"
r2="Cu2+"
# produits
p1="Al3+"
p2="Cu"

# #########################
# initialisation des variables
r_limit=""                  # contiendra le nom du réactif limitant
xmax=0
# Quantité de matières finales:
n1_fin =0
n2_fin =0
n3_fin = 0
n4_fin = 0

# ###########################
# Affichage de l'état initial du système
# mise en forme de l'affichage, En écriture scientifique, à 2 CS
#  "%.1e"%   signifie écriture scientifique à 1 chiffre après la virgule (donc 2 C.S.)
print("Etat initial du système:")
print("n("+ r1 +") = "+"%.1e"%n1_ini + " mol")
print("n("+ r2 +") = "+"%.1e"%n2_ini + " mol")
print("n("+ p1 +") = "+"%.1e"%n3_ini + " mol")
print("n("+ p2 +") = "+ "%.1e"%n4_ini + " mol")
print("-------------------------------------")


# ########################################
# recherche du réactif limitant et de xmax
""" Taper ici le code permettant de calculer xmax.
mettre dans la variable "r_limit" le nom du réactif limitant """
if n1_ini/stoechio1 < n2_ini/stoechio2:
    # si celui du 1er réactif est plus petit, c'est lui le limitant et on calcule xmax
    xmax =n1_ini/stoechio1
    # on mets dans react_limit le nom du reactif limitant
    r_limit= r1
else:
    xmax = n2_ini/stoechio2
    r_limit= r2

# ######################################
# Affichage du réactif limitant et de xmax
print("Le réactif limitant est "+r_limit)
print ("xmax="+"%.1e"%xmax+" mol")
print("----------------------------")


# ###########################################
# Calcul des quantités de matière finales
""" Saisir ci-dessous les formules permettant le calcul des quantités
de matières finales en utilisant les bonnes variables """
# formules issues de la dernière ligne d'un tableau d'avancement
n1_fin =n1_ini -stoechio1*xmax
n2_fin =n2_ini -stoechio2*xmax
n3_fin =n3_ini +stoechio3*xmax
n4_fin =n4_ini +stoechio4*xmax

# ###########################
# Affichage de l'état final du système
print("Etat final du système:")
print("n("+ r1 +") = "+"%.1e"%n1_fin + " mol")
print("n("+ r2 +") = "+"%.1e"%n2_fin+ " mol")
print("n("+ p1 +") = "+"%.1e"%n3_fin + " mol")
print("n("+ p2 +") = "+"%.1e"%n4_fin + " mol")
print("-------------------------------------")


